<?php
/**
 * 2019 Addify
 *
 * NOTICE OF LICENSE
 *
 * This source file is subject to the Academic Free License (AFL 3.0)
 * that is bundled with this package in the file LICENSE.txt.
 * It is also available through the world-wide-web at this URL:
 * http://opensource.org/licenses/afl-3.0.php
 * If you did not receive a copy of the license and are unable to
 * obtain it through the world-wide-web, please send an email
 * to license@prestashop.com so we can send you a copy immediately.
 *
 * DISCLAIMER
 *
 * Do not edit or add to this file if you wish to upgrade PrestaShop to newer
 * versions in the future. If you wish to customize PrestaShop for your
 * needs please refer to http://www.prestashop.com for more information.
 *
 *  @author    Addify
 *  @copyright 2019 Addify
 *  @license   http://opensource.org/licenses/afl-3.0.php
 */
if (!defined('_PS_VERSION_')) {
    exit;
}
class ExtHidePrice extends ObjectModel
{
    public $id;

    public $active;

    public $title;

    public $priority;

    public $hideprice;

    public $hidecart;
    public $active_custom_btn;
    public $custom_btn_title;
    public $custom_btn_link;
    public $custom_btn_text_color;
    public $custom_btn_background_color;

    public $rule_date_activate;
    public $module_rule_start_date;
    public $module_rule_expire_date;

    public $groups_activate;
    public $groups;

    public $product_type;
    public $selected_products_activate;
    public $product;

    public $category_activate;
    public $categories;

    public $supplier_activate;
    public $Supplier;

    public $manufacturer_activate;
    public $Manufacturer;

    public $price_based_activate;
    public $min_price;
    public $max_price;

    public $stock_based_activate;
    public $zero_stock_activate;
    public $custom_stock_activate;
    public $custom_stock_value;

    public $id_shop;

    public $date_upd;
    public $date_add;

    public $enabled_disabled_custom_message_mode;
    public $displaytext;
    
    /**
     * @see ObjectModel::$definition
     */
    public static $definition = array(
        'table'     => 'addifyextendedhideprice',
        'primary'   => 'id_addifyextendedhideprice',
        'multilang' => true,
        'fields'    => array(
            'active'  => array('type' => self::TYPE_BOOL, 'validate' => 'isBool'),
            'title' => array('type' => self::TYPE_HTML),
            'priority'  => array('type' => self::TYPE_BOOL),
            'hideprice'  => array('type' => self::TYPE_BOOL, 'validate' => 'isBool'),
            'hidecart'  => array('type' => self::TYPE_BOOL, 'validate' => 'isBool'),
            'active_custom_btn' => array('type' => self::TYPE_BOOL, 'validate' => 'isBool'),
            'custom_btn_title'  => array('type' => self::TYPE_HTML),
            'custom_btn_link' => array('type' => self::TYPE_HTML),
            'custom_btn_text_color' => array('type' => self::TYPE_HTML),
            'custom_btn_background_color' => array('type' => self::TYPE_HTML),
            'rule_date_activate'  => array('type' => self::TYPE_BOOL, 'validate' => 'isBool'),
            'module_rule_start_date'   => array('type' => self::TYPE_DATE, 'validate' => 'isDateFormat'),
            'module_rule_expire_date'   => array('type' => self::TYPE_DATE, 'validate' => 'isDateFormat'),
            'groups_activate'  => array('type' => self::TYPE_BOOL, 'validate' => 'isBool'),
            'groups' => array('type' => self::TYPE_HTML),
            'category_activate'  => array('type' => self::TYPE_BOOL, 'validate' => 'isBool'),
            'categories' => array('type' => self::TYPE_HTML),
            'product_type'  => array('type' => self::TYPE_BOOL),
            'selected_products_activate'  => array('type' => self::TYPE_BOOL),
            'product' => array('type' => self::TYPE_HTML),
            'supplier_activate'  => array('type' => self::TYPE_BOOL, 'validate' => 'isBool'),
            'Supplier' => array('type' => self::TYPE_HTML),
            'manufacturer_activate'  => array('type' => self::TYPE_BOOL, 'validate' => 'isBool'),
            'Manufacturer' => array('type' => self::TYPE_HTML),
            'price_based_activate'  => array('type' => self::TYPE_BOOL, 'validate' => 'isBool'),
            'min_price'  => array('type' => self::TYPE_HTML),
            'max_price'  => array('type' => self::TYPE_HTML),
            'stock_based_activate'  => array('type' => self::TYPE_BOOL, 'validate' => 'isBool'),
            'zero_stock_activate'  => array('type' => self::TYPE_BOOL, 'validate' => 'isBool'),
            'custom_stock_activate'  => array('type' => self::TYPE_BOOL, 'validate' => 'isBool'),
            'custom_stock_value'  => array('type' => self::TYPE_HTML),
            'id_shop' => array('type' => self::TYPE_HTML),
            'date_add'   => array('type' => self::TYPE_DATE, 'validate' => 'isDateFormat'),
            'date_upd' => array('type' => self::TYPE_DATE, 'validate' => 'isDateFormat'),
            'enabled_disabled_custom_message_mode'  => array('type' => self::TYPE_BOOL, 'validate' => 'isBool'),
            'displaytext'   => array('type' => self::TYPE_HTML, 'lang' => true, 'validate' => 'isCleanHtml'), // multi-lingual
        )
    );
    public static function getListContent()
    {
        return Db::getInstance()->executeS('
            SELECT cr.*, crc.`displaytext`
            FROM `'._DB_PREFIX_.'addifyextendedhideprice` cr
            '.Shop::addSqlAssociation('addifyextendedhideprice', 'cr').'
            LEFT JOIN `'._DB_PREFIX_.'addifyextendedhideprice_lang` crc
                ON (cr.`id_addifyextendedhideprice` = crc.`id_addifyextendedhideprice`)
            GROUP BY cr.`id_addifyextendedhideprice`');
    }
    public static function setStatus($status, $id)
    {
        if (!$id || empty($status)) {
            return false;
        }
        return (bool)Db::getInstance()->execute('UPDATE '._DB_PREFIX_.self::$definition['table'].'
            SET `'.pSQL($status).'` = !'.pSQL($status).'
            WHERE id_addifyextendedhideprice = '.(int)$id);
    }
    public static function searchHidePriceProduct()
    {
        $query = Tools::getValue('q', false);
        if (!$query or $query == '' or Tools::strlen($query) < 1) {
            die();
        }

        /*
         * In the SQL request the "q" param is used entirely to match result in database.
         * In this way if string:"(ref : #ref_pattern#)" is displayed on the return list,
         * they are no return values just because string:"(ref : #ref_pattern#)"
         * is not write in the name field of the product.
         * So the ref pattern will be cut for the search request.
         */
        if ($pos = strpos($query, ' (ref:')) {
            $query = Tools::substr($query, 0, $pos);
        }

        $excludeIds = Tools::getValue('excludeIds', false);
        if ($excludeIds && $excludeIds != 'NaN') {
            $excludeIds = implode(',', array_map('intval', explode(',', $excludeIds)));
        } else {
            $excludeIds = '';
            $excludePackItself= Tools::getValue('packItself', false);
        }

        // Excluding downloadable products from packs because download from pack is not supported
        $excludeVirtuals = (bool)Tools::getValue('excludeVirtuals', true);
        $exclude_packs = (bool)Tools::getValue('exclude_packs', true);

        $context = Context::getContext();

        $sql = 'SELECT p.`id_product`, pl.`link_rewrite`, p.`reference`, pl.`name`, image_shop.`id_image` id_image, il.`legend`, p.`cache_default_attribute`
                FROM `'._DB_PREFIX_.'product` p
                '.Shop::addSqlAssociation('product', 'p').'
                LEFT JOIN `'._DB_PREFIX_.'product_lang` pl ON (pl.id_product = p.id_product AND pl.id_lang = '.(int)$context->language->id.Shop::addSqlRestrictionOnLang('pl').')
                LEFT JOIN `'._DB_PREFIX_.'image_shop` image_shop
                    ON (image_shop.`id_product` = p.`id_product` AND image_shop.cover=1 AND image_shop.id_shop='.(int)$context->shop->id.')
                LEFT JOIN `'._DB_PREFIX_.'image_lang` il ON (image_shop.`id_image` = il.`id_image` AND il.`id_lang` = '.(int)$context->language->id.')
                WHERE (pl.name LIKE \'%'.pSQL($query).'%\' OR p.reference LIKE \'%'.pSQL($query).'%\')'.
            (!empty($excludeIds) ? ' AND p.id_product NOT IN ('.$excludeIds.') ' : ' ').
            (!empty($excludePackItself) ? ' AND p.id_product <> '.$excludePackItself.' ' : ' ').
            ($excludeVirtuals ? 'AND NOT EXISTS (SELECT 1 FROM `'._DB_PREFIX_.'product_download` pd WHERE (pd.id_product = p.id_product))' : '').
            ($exclude_packs ? 'AND (p.cache_is_pack IS NULL OR p.cache_is_pack = 0)' : '').
            ' GROUP BY p.id_product';

        $items = Db::getInstance()->executeS($sql);

        if ($items) {
            foreach ($items as $item) {
                $item['name'] = str_replace('|', '&#124;', $item['name']);
                echo trim($item['name']).(!empty($item['reference']) ? ' (ref: '.$item['reference'].')' : '').'|'.(int)($item['id_product'])."\n";
            }
        }
        die();
    }
    public static function getProductById($id_product)
    {
        return Db::getInstance()->getRow('SELECT `id_product`, `name`
            FROM `'._DB_PREFIX_.'product_lang` WHERE `id_product` = '.(int)$id_product);
    }
    public static function getTextDisplay($id_addifyextendedhideprice, $lang)
    {
        return Db::getInstance()->getRow('SELECT `displaytext`
            FROM `'._DB_PREFIX_.'addifyextendedhideprice_lang` WHERE `id_addifyextendedhideprice` = '.(int)$id_addifyextendedhideprice.' AND `id_lang` = '.(int)$lang);
    }

    
    public static function getRuleByProduct($productId, $categories, $id_group, $id_supplier, $id_manufacturer, $stockQuantity)
    {
        $rules = Db::getInstance()->executeS('SELECT *
            FROM `'._DB_PREFIX_.'addifyextendedhideprice` WHERE `active` = 1 ORDER BY priority ASC');

        $returnMatches = array();

        $ruleSchedulerCheck = false;
        $groupCheck = false;
        $allProducts = false;
        $searchProducts = false;
        $supplierCheck = false;
        $manufactureCheck = false;
        $priceOutOfStockChecked = false;
        $CustomStockStockChecked = false;
        $priceBasedChecked = false;

        if ($rules) {
            foreach ($rules as $rule) {    

                $ruleStartDate =  explode(',', $rule['module_rule_start_date']);
                $ruleExpiryDate =  explode(',', $rule['module_rule_expire_date']);
                $selectedProducts =  explode(',', $rule['product']);

                $ruleGroups =  explode(',', $rule['groups']);
                $ruleCategories =  explode(',', $rule['categories']);
                $ruleSuppliers =  explode(',', $rule['Supplier']);
                $ruleManufacturers =  explode(',', $rule['Manufacturer']);
                $rule_price_based_min =  explode(',', $rule['min_price']);
                $rule_stock_based_max =  explode(',', $rule['max_price']);
                $rule_custom_stock_value =  explode(',', $rule['custom_stock_value']);
                
                
                $current_date = date("Y-m-d h:i:s");
                if ($rule['rule_date_activate'] == 1) { // rule start and expiry date
                    if ($rule['module_rule_start_date'] == '0000-00-00 00:00:00' && $rule['module_rule_expire_date'] == '0000-00-00 00:00:00') {
                        $ruleSchedulerCheck = true;
                    }
                    elseif ($rule['module_rule_start_date'] && $rule['module_rule_expire_date']) {
                        if ($current_date < $rule['module_rule_start_date'] || $current_date > $rule['module_rule_expire_date']) {
                            $ruleSchedulerCheck = false;
                        }
                        else {
                            $ruleSchedulerCheck = true;
                        }
                    }
                    else {
                        $ruleSchedulerCheck = true;
                    }
                }

                
                if ($rule['groups_activate'] == 1) { // groups
                    if ($rule['groups']) {
                        if (in_array($id_group,$ruleGroups)) {
                           $groupCheck = true;
                        }
                        else {
                            $groupCheck = false;
                        }
                    }
                }
                else {
                    $groupCheck = true;
                }

                
                if ($rule['product_type'] == 1) { // if all products
                    $sql = 'SELECT p.id_product FROM '._DB_PREFIX_.'product p 
                        INNER JOIN '._DB_PREFIX_.'product_shop ps ON p.id_product = ps.id_product 
                        WHERE ps.active = 1';
                    $gettproducts = Db::getInstance()->executeS($sql);
                    foreach ($gettproducts as $gettProduct) {
                        if (in_array($productId, array($gettProduct['id_product']))) {
                            $allProducts = true;
                        }
                    }
                }
                else { // if not all products so this
                    if ($rule['selected_products_activate'] == 1) { // selected products
                        if ($rule['product']) { 
                            if (in_array($productId, $selectedProducts)) {
                                $searchProducts = true;
                            }
                            else {
                                $searchProducts = false;;
                            }
                        }
                    }

                    $categoryCheck = false;
                    $productCategories = array();
                    foreach ($categories as $value) {
                        $productCategories[] = $value['id_category'];
                    }

                    if ($rule['category_activate'] == 1) { // category
                        if ($rule['categories']) {
                            if (array_intersect($ruleCategories, $productCategories)) {
                                $categoryCheck = true;
                            }
                            else {
                                $categoryCheck = false;
                            }
                        }
                    }

                    else {
                        $rule['categories'] = '';
                    }
                    
                    
                    if ($rule['supplier_activate'] == 1) { // Supplier
                        if ($rule['Supplier']) {
                            if (in_array($id_supplier,$ruleSuppliers)) { 
                                $supplierCheck = true;
                            }
                            else {
                                $supplierCheck = false;
                            }
                        }
                    }
                    else {
                        $rule['Supplier'] = '';
                    }
                    
                    
                    if ($rule['manufacturer_activate'] == 1) { // Manufacturer
                        if ($rule['Manufacturer']) {
                            if (in_array($id_manufacturer,$ruleManufacturers)) {
                                $manufactureCheck = true;
                            }
                            else {
                                $manufactureCheck = false;
                            }
                        }
                    }
                    else {
                        $rule['Manufacturer'] = '';
                    }
                    
                    
                    if ($rule['price_based_activate'] == 1) { // min and max price
                        if ($rule['min_price'] && $rule['max_price']) {
                            $sql = 'SELECT p.id_product, p.price
                                FROM '._DB_PREFIX_.'product p
                                WHERE p.id_product = '.(int)$productId .'
                                AND p.price BETWEEN '.(float)$rule['min_price'].' AND '.(float)$rule['max_price'].'
                                AND p.active = 1';

                            $product = Db::getInstance()->getRow($sql);
                            if ($product) {
                                $priceBasedChecked = true;
                            }
                            else {
                                $priceBasedChecked = false;
                            }
                        }
                    }
                    else {
                        $rule['min_price'] = '';
                        $rule['max_price'] = '';
                    }


                    if ($rule['stock_based_activate'] == 1) { // stock
                        if ($rule['zero_stock_activate'] == 1) { // out of stock
                            if ($stockQuantity <= 0) {
                                $priceOutOfStockChecked = true;
                            }
                            else {
                                $priceOutOfStockChecked = false;
                            }
                        }

                        if ($rule['custom_stock_activate'] == 1) { // custom stock
                            if ($stockQuantity <= $rule['custom_stock_value']) {
                                $CustomStockStockChecked = true; 
                            }
                        }
                    }
                    else {
                        $rule['zero_stock_activate'] = '';
                        $rule['custom_stock_activate'] = '';
                        $rule['custom_stock_value'] = '';
                    }

                }
                
                if ($ruleSchedulerCheck) {
                    if ($allProducts || $searchProducts || $categoryCheck || $manufactureCheck || $supplierCheck || $priceBasedChecked || $priceOutOfStockChecked || $CustomStockStockChecked) {
                        if ($groupCheck) {
                            $returnMatches[] = $rule;
                        }
                    }
                }
                else {
                    if ($allProducts || $searchProducts || $categoryCheck || $manufactureCheck || $supplierCheck || $priceBasedChecked || $priceOutOfStockChecked || $CustomStockStockChecked) {
                        if ($groupCheck) {
                            $returnMatches[] = $rule;
                        }
                    }
                }
            }
            return $returnMatches;
        }
    }
}
