<?php
/**
 * 2024 Addify
 *
 * NOTICE OF LICENSE
 *
 * This source file is subject to the Academic Free License (AFL 3.0)
 * that is bundled with this package in the file LICENSE.txt.
 * It is also available through the world-wide-web at this URL:
 * http://opensource.org/licenses/afl-3.0.php
 * If you did not receive a copy of the license and are unable to
 * obtain it through the world-wide-web, please send an email
 * to license@prestashop.com so we can send you a copy immediately.
 *
 * DISCLAIMER
 *
 * Do not edit or add to this file if you wish to upgrade PrestaShop to newer
 * versions in the future. If you wish to customize PrestaShop for your
 * needs please refer to http://www.prestashop.com for more information.
 *
 *  @author    Addify
 *  @copyright 2024 Addify
 *  @license   http://opensource.org/licenses/afl-3.0.php
 */

if (!defined('_PS_VERSION_')) {
    exit;
}

/**
 * This function updates your module from previous versions to the version 1.1,
 * usefull when you modify your database, or register a new hook ...
 * Don't forget to create one file per version.
 */
function upgrade_module_1_4_0($module)
{
    Configuration::updateValue('addify_AS_live_mode', 1);

    $enabled_disabled_custom_message_mode = Db::getInstance()->executeS("SHOW COLUMNS FROM `" . _DB_PREFIX_ . "addifyextendedhideprice` LIKE 'enabled_disabled_custom_message_mode'");
    if (!$enabled_disabled_custom_message_mode) {
        Db::getInstance()->execute("ALTER TABLE `" . _DB_PREFIX_ . "addifyextendedhideprice` ADD COLUMN `enabled_disabled_custom_message_mode` TINYINT(2) DEFAULT 1");
    }

    $active_custom_btn = Db::getInstance()->executeS("SHOW COLUMNS FROM `" . _DB_PREFIX_ . "addifyextendedhideprice` LIKE 'active_custom_btn'");
    if (!$active_custom_btn) {
        Db::getInstance()->execute("ALTER TABLE `" . _DB_PREFIX_ . "addifyextendedhideprice` ADD COLUMN active_custom_btn TINYINT(2)");
    }

    $custom_btn_title = Db::getInstance()->executeS("SHOW COLUMNS FROM `" . _DB_PREFIX_ . "addifyextendedhideprice` LIKE 'custom_btn_title'");
    if (!$custom_btn_title) {
        Db::getInstance()->execute("ALTER TABLE `" . _DB_PREFIX_ . "addifyextendedhideprice` ADD COLUMN custom_btn_title TEXT");
    }

    $custom_btn_link = Db::getInstance()->executeS("SHOW COLUMNS FROM `" . _DB_PREFIX_ . "addifyextendedhideprice` LIKE 'custom_btn_link'");
    if (!$custom_btn_link) {
        Db::getInstance()->execute("ALTER TABLE `" . _DB_PREFIX_ . "addifyextendedhideprice` ADD COLUMN custom_btn_link TEXT");
    }

    $custom_btn_text_color = Db::getInstance()->executeS("SHOW COLUMNS FROM `" . _DB_PREFIX_ . "addifyextendedhideprice` LIKE 'custom_btn_text_color'");
    if (!$custom_btn_text_color) {
        Db::getInstance()->execute("ALTER TABLE `" . _DB_PREFIX_ . "addifyextendedhideprice` ADD COLUMN custom_btn_text_color TEXT");
    }

    $custom_btn_background_color = Db::getInstance()->executeS("SHOW COLUMNS FROM `" . _DB_PREFIX_ . "addifyextendedhideprice` LIKE 'custom_btn_background_color'");
    if (!$custom_btn_background_color) {
        Db::getInstance()->execute("ALTER TABLE `" . _DB_PREFIX_ . "addifyextendedhideprice` ADD COLUMN custom_btn_background_color TEXT");
    }

    $rule_date_activate = Db::getInstance()->executeS("SHOW COLUMNS FROM `" . _DB_PREFIX_ . "addifyextendedhideprice` LIKE 'rule_date_activate'");
    if (!$rule_date_activate) {
        Db::getInstance()->execute("ALTER TABLE `" . _DB_PREFIX_ . "addifyextendedhideprice` ADD COLUMN rule_date_activate TEXT");
    }

    $module_rule_start_date = Db::getInstance()->executeS("SHOW COLUMNS FROM `" . _DB_PREFIX_ . "addifyextendedhideprice` LIKE 'module_rule_start_date'");
    if (!$module_rule_start_date) {
        Db::getInstance()->execute("ALTER TABLE `" . _DB_PREFIX_ . "addifyextendedhideprice` ADD COLUMN module_rule_start_date TEXT");
    }

    $module_rule_expire_date = Db::getInstance()->executeS("SHOW COLUMNS FROM `" . _DB_PREFIX_ . "addifyextendedhideprice` LIKE 'module_rule_expire_date'");
    if (!$module_rule_expire_date) {
        Db::getInstance()->execute("ALTER TABLE `" . _DB_PREFIX_ . "addifyextendedhideprice` ADD COLUMN module_rule_expire_date TEXT");
    }

    $groups_activate = Db::getInstance()->executeS("SHOW COLUMNS FROM `" . _DB_PREFIX_ . "addifyextendedhideprice` LIKE 'groups_activate'");
    if (!$groups_activate) {
        Db::getInstance()->execute("ALTER TABLE `" . _DB_PREFIX_ . "addifyextendedhideprice` ADD COLUMN groups_activate TINYINT(2) DEFAULT 1");
    }

    $selected_products_activate = Db::getInstance()->executeS("SHOW COLUMNS FROM `" . _DB_PREFIX_ . "addifyextendedhideprice` LIKE 'selected_products_activate'");
    if (!$selected_products_activate) {
        Db::getInstance()->execute("ALTER TABLE `" . _DB_PREFIX_ . "addifyextendedhideprice` ADD COLUMN selected_products_activate TINYINT(2)");
    }

    $category_activate = Db::getInstance()->executeS("SHOW COLUMNS FROM `" . _DB_PREFIX_ . "addifyextendedhideprice` LIKE 'category_activate'");
    if (!$category_activate) {
        Db::getInstance()->execute("ALTER TABLE `" . _DB_PREFIX_ . "addifyextendedhideprice` ADD COLUMN category_activate TINYINT(2)");
    }

    $supplier_activate = Db::getInstance()->executeS("SHOW COLUMNS FROM `" . _DB_PREFIX_ . "addifyextendedhideprice` LIKE 'supplier_activate'");
    if (!$supplier_activate) {
        Db::getInstance()->execute("ALTER TABLE `" . _DB_PREFIX_ . "addifyextendedhideprice` ADD COLUMN supplier_activate TINYINT(2)");
    }

    $Supplier = Db::getInstance()->executeS("SHOW COLUMNS FROM `" . _DB_PREFIX_ . "addifyextendedhideprice` LIKE 'Supplier'");
    if (!$Supplier) {
        Db::getInstance()->execute("ALTER TABLE `" . _DB_PREFIX_ . "addifyextendedhideprice` ADD COLUMN Supplier TINYINT(2)");
    }

    $manufacturer_activate = Db::getInstance()->executeS("SHOW COLUMNS FROM `" . _DB_PREFIX_ . "addifyextendedhideprice` LIKE 'manufacturer_activate'");
    if (!$manufacturer_activate) {
        Db::getInstance()->execute("ALTER TABLE `" . _DB_PREFIX_ . "addifyextendedhideprice` ADD COLUMN manufacturer_activate TINYINT(2)");
    }

    $Manufacturer = Db::getInstance()->executeS("SHOW COLUMNS FROM `" . _DB_PREFIX_ . "addifyextendedhideprice` LIKE 'Manufacturer'");
    if (!$Manufacturer) {
        Db::getInstance()->execute("ALTER TABLE `" . _DB_PREFIX_ . "addifyextendedhideprice` ADD COLUMN Manufacturer TINYINT(2)");
    }

    $price_based_activate = Db::getInstance()->executeS("SHOW COLUMNS FROM `" . _DB_PREFIX_ . "addifyextendedhideprice` LIKE 'price_based_activate'");
    if (!$price_based_activate) {
        Db::getInstance()->execute("ALTER TABLE `" . _DB_PREFIX_ . "addifyextendedhideprice` ADD COLUMN price_based_activate TINYINT(2)");
    }

    $min_price = Db::getInstance()->executeS("SHOW COLUMNS FROM `" . _DB_PREFIX_ . "addifyextendedhideprice` LIKE 'min_price'");
    if (!$min_price) {
        Db::getInstance()->execute("ALTER TABLE `" . _DB_PREFIX_ . "addifyextendedhideprice` ADD COLUMN min_price TEXT");
    }

    $max_price = Db::getInstance()->executeS("SHOW COLUMNS FROM `" . _DB_PREFIX_ . "addifyextendedhideprice` LIKE 'max_price'");
    if (!$max_price) {
        Db::getInstance()->execute("ALTER TABLE `" . _DB_PREFIX_ . "addifyextendedhideprice` ADD COLUMN max_price TEXT");
    }

    $stock_based_activate = Db::getInstance()->executeS("SHOW COLUMNS FROM `" . _DB_PREFIX_ . "addifyextendedhideprice` LIKE 'stock_based_activate'");
    if (!$stock_based_activate) {
        Db::getInstance()->execute("ALTER TABLE `" . _DB_PREFIX_ . "addifyextendedhideprice` ADD COLUMN stock_based_activate TINYINT(2)");
    }

    $zero_stock_activate = Db::getInstance()->executeS("SHOW COLUMNS FROM `" . _DB_PREFIX_ . "addifyextendedhideprice` LIKE 'zero_stock_activate'");
    if (!$zero_stock_activate) {
        Db::getInstance()->execute("ALTER TABLE `" . _DB_PREFIX_ . "addifyextendedhideprice` ADD COLUMN zero_stock_activate TINYINT(2)");
    }

    $custom_stock_activate = Db::getInstance()->executeS("SHOW COLUMNS FROM `" . _DB_PREFIX_ . "addifyextendedhideprice` LIKE 'custom_stock_activate'");
    if (!$custom_stock_activate) {
        Db::getInstance()->execute("ALTER TABLE `" . _DB_PREFIX_ . "addifyextendedhideprice` ADD COLUMN custom_stock_activate TINYINT(2)");
    }

    $custom_stock_value = Db::getInstance()->executeS("SHOW COLUMNS FROM `" . _DB_PREFIX_ . "addifyextendedhideprice` LIKE 'custom_stock_value'");
    if (!$custom_stock_value) {
        Db::getInstance()->execute("ALTER TABLE `" . _DB_PREFIX_ . "addifyextendedhideprice` ADD COLUMN custom_stock_value TEXT");
    }

    return true;
}