{*
* 2019 Addify
*
* NOTICE OF LICENSE
*
* This source file is subject to the Academic Free License (AFL 3.0)
* that is bundled with this package in the file LICENSE.txt.
* It is also available through the world-wide-web at this URL:
* http://opensource.org/licenses/afl-3.0.php
* If you did not receive a copy of the license and are unable to
* obtain it through the world-wide-web, please send an email
* to license@prestashop.com so we can send you a copy immediately.
*
* DISCLAIMER
*
* Do not edit or add to this file if you wish to upgrade PrestaShop to newer
* versions in the future. If you wish to customize PrestaShop for your
* needs please refer to http://www.prestashop.com for more information.
*
*  @author    Addify
*  @copyright 2019 Addify
*  @license   http://opensource.org/licenses/afl-3.0.php
*}

{extends file="helpers/form/form.tpl"}

{block name="input"}

    {if $input.type == "hideprice_product"}
      <div id="type_product" class="col-lg-9">
        <input type="hidden" name="inputRestrictedProducts" id="inputRestrictedProducts" value="{if isset($products) AND $products}{foreach from=$products item=product}{$product.id_product|escape:'htmlall':'UTF-8'}-{/foreach}{/if}" />
        <input type="hidden" name="nameRestrictedProducts" id="nameRestrictedProducts" value="{if isset($products) AND $products}{foreach from=$products item=product}{$product.name|escape:'html':'UTF-8'}¤{/foreach}{/if}" />
        <div id="ajax_choose_product">
          <div class="input-group">
            <input type="text" id="restricted_product_input" name="restricted_product_input" />
            <span class="input-group-addon"><i class="icon-search"></i></span>
          </div>
        </div>
        <p class="help-block">{l s='Search and add product(s) to hide prices.' mod='addifyextendedhideprice'}</p>
        <br>

        <div id="divRestrictedProducts">
          {if isset($products) AND $products}
            {foreach from=$products item=product}
              <div class="form-control-static panel">
                <button type="button" class="btn btn-danger delRestrictedProducts" name="{$product.id_product|escape:'htmlall':'UTF-8'}">
                  <i class="icon-trash text-danger"></i>
                </button>
                <input type="hidden" name="product[]" value="{$product.id_product|escape:'htmlall':'UTF-8'}">
                {$product.name|escape:'html':'UTF-8'}{if !empty($product.reference)}&nbsp;{l s='(ref: %s)' sprintf=$product.reference mod='addifyextendedhideprice'}{/if}
              </div>
            {/foreach}
          {/if}
        </div>
      </div>
      <div class="clearfix"></div>
    {else}
      {$smarty.block.parent}
    {/if}
{/block}

{block name="script"}
  
  var active_type = "{if isset($fields_value) AND isset($fields_value.type)}{$fields_value.type|escape:'htmlall':'UTF-8'}{/if}";
  if (typeof active_type === 'undefined' || active_type === '') {
    active_type = $('#type option:selected').val();
  }

  init_types(active_type);

  $(document).on('change', '#type', function(){
    init_types($(this).val());
  });

  $('#divRestrictedProducts').delegate('.delRestrictedProducts', 'click', function() {
    self.delRestrictedProducts($(this).attr('name'));
  });
  
  var options = {
    minChars: 1,
    autoFill: true,
    max:20,
    matchContains: true,
    mustMatch:false,
    scroll:false,
    cacheLength:0,
    formatItem: function(item) {
      var itemStringToReturn = item[item.length - 1];
      for(var istr = 0; istr < item.length - 1;istr++) {
        itemStringToReturn += " " + item[istr];
      }
      return itemStringToReturn;
    },
    
  };

  $('#restricted_product_input')
  .autocomplete("{$context_link->getAdminLink('AdminHidePrice') nofilter}&exclude_packs=0&excludeVirtuals=0",options)
  .result(addProduct);
  $('#restricted_product_input').setOptions({
    extraParams: {
      ajax: true,
      action: 'getProducts',
      excludeIds: getRestrictedProduct()
    }
  });

  function addProduct(event, data, formatted) {
    if (data !== null) {
      var productId = data[1];
      var productName = data[0];

      var $divRestrictedProducts = $('#divRestrictedProducts');
      var $inputRestrictedProducts = $('#inputRestrictedProducts');
      var $nameRestrictedProducts = $('#nameRestrictedProducts');

      /* delete product from select + add product line to the div, input_name, input_ids elements */
      $divRestrictedProducts.html($divRestrictedProducts.html() + '<div class="form-control-static panel"><button type="button" class="delRestrictedProducts btn btn-danger" name="' + productId + '"><i class="icon-trash text-danger"></i></button>&nbsp;'+ productName +'</div><input type="hidden" name="product[]" value="' + productId + '">');
      $nameRestrictedProducts.val($nameRestrictedProducts.val() + productName + '¤');
      ($inputRestrictedProducts.val() !== 'undefined')?$inputRestrictedProducts.val($inputRestrictedProducts.val() + productId + '-'):$inputRestrictedProducts.val(productId + '-');
      $('#restricted_product_input').val('');
      $('#restricted_product_input').setOptions({
        extraParams: {
          ajax: true,
          action: 'getProducts',
          excludeIds : getRestrictedProduct()
        }
      });
    }
  }

  function getRestrictedProduct() {
    if ($('#inputRestrictedProducts').val() !== undefined) {
      return $('#inputRestrictedProducts').val().replace(/\-/g,',');
    }
  }

  function delRestrictedProducts(id) {
    var div = getE('divRestrictedProducts');
    var input = getE('inputRestrictedProducts');
    var name = getE('nameRestrictedProducts');

    // Cut hidden fields in array
    var inputCut = input.value.split('-');
    var nameCut = name.value.split('¤');

    if (inputCut.length != nameCut.length) {
      return jAlert('Bad size');
    }

    // Reset all hidden fields
    input.value = '';
    name.value = '';
    div.innerHTML = '';
    for (i in inputCut)
    {
      // If empty, error, next
      if (!inputCut[i] || !nameCut[i]) {
        continue ;
      }

      // Add to hidden fields no selected products OR add to select field selected product
      if (inputCut[i] != id) {
        input.value += inputCut[i] + '-';
        name.value += nameCut[i] + '¤';
        div.innerHTML += '<div class="form-control-static panel"><button type="button" class="delRestrictedProducts btn btn-danger" name="' + inputCut[i] +'"><i class="icon-trash text-danger"></i></button>&nbsp;' + nameCut[i] + '</div><input type="hidden" name="product[]" value="' + inputCut[i] +'">';
      } else {
        $('#selectRestrictedProducts').append('<option selected="selected" value="' + inputCut[i] + '-' + nameCut[i] + '">' + inputCut[i] + ' - ' + nameCut[i] + '</option>');
      }
    }

    $('#restricted_product_input').setOptions({
      extraParams: {
        ajax: true,
        action: 'getProducts',
        excludeIds : getRestrictedProduct()
      }
    });
  };

  function init_types(active_type) {
    if (active_type==2) {
      $('#type_product').closest('.form-group').show();
    } else {
      $('#type_product').closest('.form-group').hide();
    }
  }
   
   // ------------------------------- hide and show --------------------------------
   // --------------- // rule start and expiry date --------------
    $("#rule_date_activate_on").click(function() {
      $('#module_rule_start_date').closest('.form-group').show();
      $('#module_rule_expire_date').closest('.form-group').show();
    });

    $("#rule_date_activate_off").click(function() {
      $('#module_rule_start_date').closest('.form-group').hide();
      $('#module_rule_expire_date').closest('.form-group').hide();
    });

    var ruleDate = $('input[name="rule_date_activate"]:checked').val();
    if (ruleDate == 1) {
      $('#module_rule_start_date').closest('.form-group').show();
      $('#module_rule_expire_date').closest('.form-group').show();
    } else {
      $('#module_rule_start_date').closest('.form-group').hide();
      $('#module_rule_expire_date').closest('.form-group').hide();
    }

    // ------------------ // Groups ----------------
    $("#groups_activate_on").click(function(){
      $(".groupBox").closest('.form-group').show();
    });

    $("#groups_activate_off").click(function(){
      $(".groupBox").closest('.form-group').hide();
    });

    if (document.getElementById("groups_activate_off")) {
      var group_activ = document.getElementById("groups_activate_off").checked;
      if (group_activ != "") {
        $(".groupBox").closest('.form-group').hide();
      }
    }
    
    // ---------------- // All products -------------
    $("#type_on").click(function() {
      $("input[name='selected_products_activate']").closest('.form-group').hide();
      $("input[name='restricted_product_input']").closest('.form-group').hide();
      $("input[name='category_activate']").closest('.form-group').hide();
      $("input[name='category[]']").closest('.form-group').hide();
      $("input[name='supplier_activate']").closest('.form-group').hide();
      $("#Supplier").closest('.form-group').hide();
      $("input[name='manufacturer_activate']").closest('.form-group').hide();
      $("#Manufacturer").closest('.form-group').hide();
      $("input[name='price_based_activate']").closest('.form-group').hide();
      $("input[name='min_price']").closest('.form-group').hide();
      $("input[name='max_price']").closest('.form-group').hide();
      $("input[name='stock_based_activate']").closest('.form-group').hide();
      $("input[name='zero_stock_activate']").closest('.form-group').hide();
      $("input[name='custom_stock_activate']").closest('.form-group').hide();
      $("input[name='custom_stock_value']").closest('.form-group').hide();
    });

    $("#type_off").click(function() {
      
      if ($("input[name='selected_products_activate']:checked").val() === "1") {
        $("input[name='selected_products_activate']").closest('.form-group').show();
        $("input[name='restricted_product_input']").closest('.form-group').show(); 
      } else {
        $("input[name='selected_products_activate']").closest('.form-group').show();
        $("input[name='restricted_product_input']").closest('.form-group').hide(); 
      }

      if ($("input[name='category_activate']:checked").val() === "1") {
        $("input[name='category_activate']").closest('.form-group').show();
        $("input[name='category[]']").closest('.form-group').show(); 
      } else {
        $("input[name='category_activate']").closest('.form-group').show();
        $("input[name='category[]']").closest('.form-group').hide(); 
      }

      if ($("input[name='supplier_activate']:checked").val() === "1") {
        $("input[name='supplier_activate']").closest('.form-group').show();
        $("input[name='Supplier']").closest('.form-group').show(); 
      } else {
        $("input[name='supplier_activate']").closest('.form-group').show();
        $("input[name='Supplier']").closest('.form-group').hide(); 
      }

      if ($("input[name='manufacturer_activate']:checked").val() === "1") {
        $("input[name='manufacturer_activate']").closest('.form-group').show();
        $("input[name='Manufacturer']").closest('.form-group').show(); 
      } else {
        $("input[name='manufacturer_activate']").closest('.form-group').show();
        $("input[name='Manufacturer']").closest('.form-group').hide(); 
      }

      if ($("input[name='price_based_activate']:checked").val() === "1") {
        $("input[name='price_based_activate']").closest('.form-group').show();
        $("input[name='min_price']").closest('.form-group').show(); 
        $("input[name='max_price']").closest('.form-group').show(); 

      } else {
        $("input[name='price_based_activate']").closest('.form-group').show();
        $("input[name='min_price']").closest('.form-group').hide();
        $("input[name='max_price']").closest('.form-group').hide(); 
      }

      if ($("input[name='stock_based_activate']:checked").val() === "1") {
        $("input[name='stock_based_activate']").closest('.form-group').show();
        $("input[name='zero_stock_activate']").closest('.form-group').show();
        $("input[name='custom_stock_activate']").closest('.form-group').show();
        $("input[name='custom_stock_value']").closest('.form-group').show(); 
      } else {
        $("input[name='stock_based_activate']").closest('.form-group').show();
        $("input[name='zero_stock_activate']").closest('.form-group').hide(); 
        $("input[name='custom_stock_activate']").closest('.form-group').hide();
        $("input[name='custom_stock_value']").closest('.form-group').hide(); 
      }

    });

    if (document.getElementById("type_on")) {
      var productChecked = document.getElementById("type_on").checked;
      if (productChecked != '') {
        $("input[name='selected_products_activate']").closest('.form-group').hide();
        $("#restricted_product_input").closest('.form-group').hide();
        $("input[name='category_activate']").closest('.form-group').hide();
        $("input[name='category[]']").closest('.form-group').hide();
        $("input[name='supplier_activate']").closest('.form-group').hide();
        $("#Supplier").closest('.form-group').hide();
        $("input[name='manufacturer_activate']").closest('.form-group').hide();
        $("#Manufacturer").closest('.form-group').hide();
        $("input[name='price_based_activate']").closest('.form-group').hide();
        $("input[name='min_price']").closest('.form-group').hide();
        $("input[name='max_price']").closest('.form-group').hide();
        $("input[name='stock_based_activate']").closest('.form-group').hide();
        $("input[name='zero_stock_activate']").closest('.form-group').hide();
        $("input[name='custom_stock_activate']").closest('.form-group').hide();
        $("input[name='custom_stock_value']").closest('.form-group').hide();
      }
      else {
        $("#restricted_product_input").closest('.form-group').show();
      }
    }

    // ---------------- // Search products -------------------
    $("#selected_products_activate_on").click(function() {
      $("#restricted_product_input").closest('.form-group').show();
    });

    $("#selected_products_activate_off").click(function(){
      $("#restricted_product_input").closest('.form-group').hide();
    });

    if (document.getElementById("selected_products_activate_off")) {
      var productt = document.getElementById("selected_products_activate_off").checked;
      if (productt != "") {
        $("#restricted_product_input").closest('.form-group').hide();
      }
    }

    // --------------- // Categories ----------------
    $("#category_activate_on").click(function(){
      $("input[name='category[]']").closest('.form-group').show();
    });

    $("#category_activate_off").click(function(){
      $("input[name='category[]']").closest('.form-group').hide();
    });

    $(document).ready(function() {
      var categoryCheckbox = document.getElementById("category_activate_off");
      if (categoryCheckbox) {
        var isChecked = categoryCheckbox.checked;
        if (isChecked) {
          $("input[name='category[]']").closest('.form-group').hide();
        }
      }
    });

    // ---------- // supplier --------------------
    $("#supplier_activate_on").click(function(){
      $("#Supplier").closest('.form-group').show();
    });

    $("#supplier_activate_off").click(function(){
      $("#Supplier").closest('.form-group').hide();
    });

    if (document.getElementById("supplier_activate_off")) {
      var supplierh = document.getElementById("supplier_activate_off").checked;
      if (supplierh != "") {
        $("#Supplier").closest('.form-group').hide();
      }
    }
    
    // ------------ // manufacurer ------------------
    $("#manufacturer_activate_on").click(function(){
      $("#Manufacturer").closest('.form-group').show();
    });

    $("#manufacturer_activate_off").click(function(){
      $("#Manufacturer").closest('.form-group').hide();
    });

    if (document.getElementById("manufacturer_activate_off")) {
      var manufacurerh = document.getElementById("manufacturer_activate_off").checked;
      if (manufacurerh != "") {
        $("#Manufacturer").closest('.form-group').hide();
      }
    }
    
    // ----------- // Price based -------------------
    $("#price_based_activate_on").click(function(){
        $("#min_price").closest('.form-group').show();
        $("#max_price").closest('.form-group').show();
    });

    $("#price_based_activate_off").click(function(){
        $("#min_price").closest('.form-group').hide();
        $("#max_price").closest('.form-group').hide();
    });

    if (document.getElementById("price_based_activate_off")) {
      var manufacurerh = document.getElementById("price_based_activate_off").checked;
      if (manufacurerh != "") {
        $("#min_price").closest('.form-group').hide();
        $("#max_price").closest('.form-group').hide();
      }
    }

    // ----------- // Stock based --------------------------------
    $("#stock_based_activate_on").click(function() {
      $("#zero_stock_activate_on").closest('.form-group').show();
      $("#custom_stock_activate_on").closest('.form-group').show();

      if ($("input[name='custom_stock_activate_on']:checked").val() === "1") { 
        $("input[name='custom_stock_activate_on']").closest('.form-group').show();
        $("input[name='custom_stock_value']").closest('.form-group').show(); 
      } else {
        $("input[name='custom_stock_activate_on']").closest('.form-group').show();
        $("input[name='custom_stock_value']").closest('.form-group').hide(); 
      }

    });

    $("#stock_based_activate_off").click(function() {
      $("#zero_stock_activate_on").closest('.form-group').hide();
      $("#custom_stock_activate_on").closest('.form-group').hide();
  
      if ($("input[name='stock_based_activate_on']:checked").val() === "1") {
        $("input[name='stock_based_activate_on']").closest('.form-group').show();
        $("input[name='custom_stock_value']").closest('.form-group').show(); 
      } else {
        $("input[name='stock_based_activate_on']").closest('.form-group').show();
        $("input[name='custom_stock_value']").closest('.form-group').hide(); 
      }

    });

    if (document.getElementById("stock_based_activate_off")) {
      var stockbasedd = document.getElementById("stock_based_activate_off").checked;
      if (stockbasedd != "") {
        $("#zero_stock_activate_on").closest('.form-group').hide();
        $("#custom_stock_activate_on").closest('.form-group').hide();
        $("#custom_stock_value").closest('.form-group').hide();
      }
    }

    // ------------ // custom stock -------------------------------
    $("#custom_stock_activate_on").click(function(){
      $("#custom_stock_value").closest('.form-group').show();
    });

    $("#custom_stock_activate_off").click(function(){
      $("#custom_stock_value").closest('.form-group').hide();
    });

    if (document.getElementById("custom_stock_activate_off")) {
      var stockbasedd = document.getElementById("custom_stock_activate_off").checked;
      if (stockbasedd != "") {
        $("#custom_stock_value").closest('.form-group').hide();
      }
    }   

    // ----------------- // message -------------------------------
    $(document).ready(function() {
        if ($("input[name='enabled_disabled_custom_message_mode']:checked").val() === '0') { 
            hideEditorMessage(false); 
        }
    });

    function hideEditorMessage(show = false) {
        $('.form-group label').filter(function() {
            return $(this).text().includes('Add Custom Message');
        }).closest('.form-group').toggle(show);
    }

    // --------------- // hide price ---------------------------
    $(document).ready(function() {
      const priceTextColor = $("input[name='text_color']").closest('.form-group').parent().parent();
      const priceBackgroundColor = $("input[name='text_bg_color']").closest('.form-group').parent().parent();
      const customMessageField = $("input[name='enabled_disabled_custom_message_mode']").closest('.form-group');

      // text color, background color
      function togglePriceFields(show) {
          priceTextColor.toggle(show);
          priceBackgroundColor.toggle(show);
      }

      // editor message mode changes
      function handleCustomMessageMode() {
          const isEnabled = $("input[name='enabled_disabled_custom_message_mode']:checked").val() === '1';
          togglePriceFields(isEnabled);
          hideEditorMessage(isEnabled);
      }

      // Handle hide price option changes
      function handleHidePriceChange() {
          const hidePriceChecked = $('#hideprice_on').is(':checked');

          hideEditorMessage(false)
          
          customMessageField.toggle(hidePriceChecked);  // Show/hide the custom message field
          hidePriceChecked ? handleCustomMessageMode() : togglePriceFields(false);  // Show/hide price fields based on state
      }

      handleHidePriceChange(); // Initial setup based on the current state

      // Event listeners for changes
      $('input[name="enabled_disabled_custom_message_mode"]').on('change', handleCustomMessageMode);
      $('input[name="hideprice"]').on('change', function() {
          handleHidePriceChange(); // Calls the handleHidePriceChange function
      });
  });

    // -------------- // Hide add to cart button --- Custom btn ----- Custom btn link ----------- Color ------ Background color --------
    $("#hidecart_on").click(function() {

      $("input[name='active_custom_btn']").closest('.form-group').show();
     
      $("#active_custom_btn_on").click(function() {
          if ($(this).is(':checked')) { 
              $("input[name='custom_btn_title']").closest('.form-group').show();
              $("input[name='custom_btn_link']").closest('.form-group').show();
              $("input[name='custom_btn_text_color']").closest('.form-group').parent().parent().show();
              $("input[name='custom_btn_background_color']").closest('.form-group').parent().parent().show();  
          }
      });

      $("#active_custom_btn_off").click(function() {
        if ($(this).is(':checked')) { 
              $("input[name='custom_btn_title']").closest('.form-group').hide();
              $("input[name='custom_btn_link']").closest('.form-group').hide();
              $("input[name='custom_btn_text_color']").closest('.form-group').parent().parent().hide();
              $("input[name='custom_btn_background_color']").closest('.form-group').parent().parent().hide();  
          }
      });

    });

    $("#hidecart_off").click(function() {

      $("input[name='active_custom_btn']").closest('.form-group').hide();
      $("input[name='custom_btn_title']").closest('.form-group').hide();
      $("input[name='custom_btn_link']").closest('.form-group').hide();
      $("input[name='custom_btn_text_color']").closest('.form-group').parent().parent().hide();
      $("input[name='custom_btn_background_color']").closest('.form-group').parent().parent().hide(); 
  
        $("#active_custom_btn_off").click(function() {
          if ($(this).is(':checked')) { // If the button is checked (active)
              $("input[name='custom_btn_title']").closest('.form-group').show();
              $("input[name='custom_btn_link']").closest('.form-group').show();
              $("input[name='custom_btn_text_color']").closest('.form-group').parent().parent().show();
              $("input[name='custom_btn_background_color']").closest('.form-group').parent().parent().show();  
          } else { // If the button is not checked (off)
              $("input[name='custom_btn_title']").closest('.form-group').hide();
              $("input[name='custom_btn_link']").closest('.form-group').hide();
              $("input[name='custom_btn_text_color']").closest('.form-group').parent().parent().hide();
              $("input[name='custom_btn_background_color']").closest('.form-group').parent().parent().hide();  
          }
      });

    });

    if (document.getElementById("hidecart_off")) {
      var hidecartt = document.getElementById("hidecart_off").checked;
      if (hidecartt != "") {
        $("input[name='active_custom_btn']").closest('.form-group').hide();
        $("input[name='custom_btn_title']").closest('.form-group').hide();
        $("input[name='custom_btn_link']").closest('.form-group').hide();
        $("input[name='custom_btn_text_color']").closest('.form-group').parent().parent().hide();
        $("input[name='custom_btn_background_color']").closest('.form-group').parent().parent().hide();
      }
    }

    // ------------ custom btn -------------
    $("#active_custom_btn_on").click(function() {
        $("input[name='custom_btn_title']").closest('.form-group').show();
        $("input[name='custom_btn_link']").closest('.form-group').show();
        $("input[name='custom_btn_text_color']").closest('.form-group').parent().parent().show();
        $("input[name='custom_btn_background_color']").closest('.form-group').parent().parent().show();
    });

    $("#active_custom_btn_off").click(function() {
        $("input[name='custom_btn_title']").closest('.form-group').hide();
        $("input[name='custom_btn_link']").closest('.form-group').hide();
        $("input[name='custom_btn_text_color']").closest('.form-group').parent().parent().hide();
        $("input[name='custom_btn_background_color']").closest('.form-group').parent().parent().hide();
    });

    if (document.getElementById("active_custom_btn_off")) {
      var hidecartt = document.getElementById("active_custom_btn_off").checked;
      if (hidecartt != "") {
        $("input[name='active_custom_btn']").closest('.form-group').hide();
        $("input[name='custom_btn_title']").closest('.form-group').hide();
        $("input[name='custom_btn_link']").closest('.form-group').hide();
        $("input[name='custom_btn_text_color']").closest('.form-group').parent().parent().hide();
        $("input[name='custom_btn_background_color']").closest('.form-group').parent().parent().hide();
      }
    }

     // ----------------- Prods Load ------------
      // var searchProductsStatus = document.querySelector("input[name='active_products']:checked").value;
      // if (searchProductsStatus === '1') {
      //   $("input[name='inputRestrictedProducts']").closest('.form-group').show();
      //   $("input[name='minproduct_quantity']").closest('.form-group').show();
      //   $("input[name='maxproduct_quantity']").closest('.form-group').show();
      //   $("input[name='ADDIFYLIMITORDERQUANTITY_PROCUCTQUANTITY_DAYSLIMIT']").closest('.form-group').show();
      // }
      // else {
      //   $("input[name='inputRestrictedProducts']").closest('.form-group').hide();
      //   $("input[name='minproduct_quantity']").closest('.form-group').hide();
      //   $("input[name='maxproduct_quantity']").closest('.form-group').hide();
      //   $("input[name='ADDIFYLIMITORDERQUANTITY_PROCUCTQUANTITY_DAYSLIMIT']").closest('.form-group').hide();
      // }
        
{/block}